/*---------------------------------------------------------------------------
 * say.c
 * Air Board Ver3.0 o^p
 * for UNIX
 *
 * LastModified:1998/01/01
 *
 * Copyright(C) 1997  Yuto Ikeno  All rights reserved.
 * e-mail:mew@post.co.jp
 * homepage:http://www.izanami.net/mew/
 *
 *-------------------------------------------------------------------------*/

/*--- defines --*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "cgi.h"
#include "mewcgi.h"


/*--- \j̕ ---*/
static const char *weekday[]={"","","","","","","y"};

/*--- code ---*/

/*--- o^ ---*/
void contribute_description(int number, struct tm *gmt, char **value){

	char fname[20];
	char *remotehost,*useragent;
	FILE *fp;

	if((useragent = getenv("HTTP_USER_AGENT")) == NULL){	/*HTTP_USER_AGENT̓ǂݍ*/
		puts("Could not read HTTP_USER_AGENT !\n");
		useragent = "\0";
	}
	if((remotehost = getenv("REMOTE_HOST")) == NULL){	/*REMOTE_HOST̓ǂݍ*/
		if((remotehost = getenv("REMOTE_ADDR")) == NULL){	/*REMOTE_ADDR̓ǂݍ*/
			puts("Could not read REMOTE_ADDR !\n");
			remotehost = "\0";
		}
	}
	sprintf(fname,"./file/%d",number);

	if((fp = fopen(fname,"w")) == NULL)
		fatal_error("炩̃G[܂B<BR>悤ȃG[xoꍇ͊Ǘ҂ɘAĂB",BODY1);

	/*e𔭌t@CtH[}bgɏ]ď*/
	fprintf(fp,"%05d\n",number);		/*--- [0]ԍ ---*/
	fprintf(fp,"%02d%02d(%s)%02d%02d\n",gmt->tm_mon+1,gmt->tm_mday,weekday[gmt->tm_wday],gmt->tm_hour,gmt->tm_min);
	fprintf(fp,"%s\n",*(value + 3));	/*--- [2] ---*/
	fprintf(fp,"%s\n",*(value + 4));	/*--- [3][AhX ---*/
	fprintf(fp,"\n");					/*--- [4]gp ---*/
	fprintf(fp,"%s\n",*value);			/*--- [5]^Cg ---*/
	fprintf(fp,"%s\n",useragent);		/*--- [6][U[G[WFg ---*/
	fprintf(fp,"%s\n",remotehost);		/*--- [7][gzXg ---*/
	fprintf(fp,"%s\n",*(value + 6));	/*--- [8]Rgԍ ---*/
	fprintf(fp,"%s\n",*(value + 7));	/*--- [9]Rg ---*/
	fprintf(fp,"0\n");					/*--- [10]i͒ʏ픭Ȃ̂0j*/
	fprintf(fp,"%s\n",*(value + 2));	/*--- [11]URL ---*/
	fprintf(fp,"\n\n\n");				/*--- [12-14]c̖gp̈̏óiŝ݁j---*/
	fprintf(fp,"%s",*(value + 1));		/*--- [15]Rg ---*/
	fclose(fp);
}

/*--- o^z̍폜 ---*/
void limit_description(int number){

	char fname[20];
	int i;

	if(REGMAX != 0 && REGMAX < number){
		for(i = (number - REGMAX); ; i--){
			sprintf(fname,"./file/%d",i);
			if(unlink(fname) != 0)
				break;
		}
	}
}

/*--- emF ---*/
void confirm_description(char **name, char **value){

	int i;

	puts("Content-type: text/html\n\n");	/*CGIwb_̏o*/
	puts(TBODY);
	puts("<BR><TABLE BORDER=0 CELLPADDING=3 WIDTH=98%>");
	printf("<TR BGCOLOR=%s NOWRAP><TH COLSPAN=2>o^e̊mF",CONFIRM_TOP1);
	printf("<TR BGCOLOR=%s NOWRAP><TD WIDTH=20%% NOWRAP>^Cg<TD WIDTH=80%% NOWRAP>%s",CONFIRM_BODY1,*value);
	printf("<TR BGCOLOR=%s NOWRAP><TD VALIGN=TOP>e<TD><PRE>%s",CONFIRM_BODY1,*(value + 1));
	if(*(*(value + 2) + 7) != '\0')
		printf("<TR BGCOLOR=%s><TD>URL<TD>%s",CONFIRM_BODY1,*(value + 2));
	printf("<TR BGCOLOR=%s NOWRAP><TD><TD>%s",CONFIRM_BODY1,*(value + 3));
	printf("<TR BGCOLOR=%s NOWRAP><TD>[AhX<TD>%s",CONFIRM_BODY1,*(value + 4));
	puts("</TABLE><FORM ACTION=\"say.cgi\" METHOD=POST>");
	for(i = 0; i< 8; i++)
		printf("<INPUT TYPE=HIDDEN NAME=\"%s\" VALUE=\"%s\">",*(name + i),*(value + i));
	puts("</CENTER><INPUT TYPE=SUBMIT VALUE=\"@@o@@^@@\">");
	puts("<INPUT TYPE=HIDDEN NAME=type VALUE=confirmed>");
	puts("</FORM>");

}
int main(void){

	int i;					/*JE^*/
	int number;				/*ԍ*/
	int flag = 1;			/*replacestring̕I[ʗp*/
	int ctype = 0;			/*mFtH[tO*/
	int confirm = 0;		/*mF̂ǂ*/
	int count;				/*tH[f[^name=valuȇg*/
	char *refer;			/*ϐ*/
	char *buffer,*buffer2;	/*obt@*/
	char **name, **value;	/*tH[f[^𕪊namevalue*/
	struct tm *gmt;			/*Ԏ擾̂߂tm\*/
	time_t ti;

	ti = time(NULL);
	ti += 9*60*60;     /*GMTJST*/
	gmt = gmtime(&ti);

	/*--- OtH[ɂUh~ ---*/
	if((refer = getenv("HTTP_REFERER")) == NULL)	/*HTTP_REFERER̓ǂݍ*/
		fatal_error("Ȍ݂͋Ă܂B",BODY1);

	buffer = (char *)malloc(strlen(refer));
	if(buffer == NULL)
		return 1;
	decode(refer);
	split(buffer,refer,'?');
	if(strcmp(buffer,SCURL1) != 0){
		if(strcmp(buffer,SCURL3) != 0)
			fatal_error("Ȍ݂͋Ă܂B",BODY1);
		else
			confirm = 1;
	}
	free(buffer);
	/*------------------------------------------*/

	count = getdata(&name, &value);	/*stdout珑ݓe擾*/

	/*--- e珑݃^Cvo ---*/
	for(i = 0; i < count; i++){
		if(!strcmp(*(name + i),"type")){
			if(!strcmp(*(value + i),"confirm")){
				ctype = 1;
			}else if(!strcmp(*(value + i),"confirmed")){
				ctype = 2;
			}
		}
	}

	/*--- ݓeH ---*/
	for(i = 0; i < count; i++){
		buffer = (char *)malloc(strlen(*(value + i)) * 5);
		buffer2 = (char *)malloc(strlen(*(value + i)) * 5);

		/*--- RgȊÓAs ---*/
		if(i != 1)
			split(buffer,*(value + i),'\n');
		else
			strcpy(buffer,*(value + i));

		/*--- ^O𖳌 ---*/
		if(ctype != 2 && TAG == 0){
			while(flag == 1){
				strcpy(buffer2,replacestring(buffer,"<","&lt;",&flag));
				strcpy(buffer,buffer2);
			}
			flag = 1;
		}

		/*--- _uNH[e[Vϊ ---*/
		if(ctype == 1){
			while(flag == 1){
				strcpy(buffer2,replacestring(buffer,(char*)"\"","&#34;",&flag));
				strcpy(buffer,buffer2);
			}
			flag = 1;
		}else if(ctype == 2){
			while(flag == 1){
			strcpy(buffer2,replacestring(buffer,(char*)"&#34;",(char*)"\"",&flag));
			strcpy(buffer,buffer2);
			}
			flag = 1;
		}

		/*--- [mۂ ---*/
		free(*(value + i));
		*(value + i) = (char *)malloc(strlen(buffer) + 1);
		strcpy(*(value + i),buffer);
		free(buffer);		/*ꎞƈ*/
		free(buffer2);
	}

	/*----- tH[ɖ݂͗ꍇ ---*/
	if(**value == '\0')
		strcpy(*value,"ij");
	if(**(value + 3) == '\0')
		fatal_error("nh͕̓͂K{łB<BR>xAm߂B",BODY1);
	if(**(value + 5) == '\0')
		fatal_error("pX[h͕̓͂K{łB<BR>xAm߂B",BODY1);
	/*------------------------------------------*/

	/*--- mF ---*/
	if(ctype == 1){
		confirm_description(name, value);
		return 0;
	}

	/*--- NbL[Ǝ̃tH[}bgŏo ---*/
	printf("Set-Cookie:%s=%s*%s^%s*%s^%s*%s^confirm*%d; Expires=Fri, 29-Sep-1999 00:00:00 GMT;",CKNAME,*(name + 3),*(value + 3),*(name + 4),*(value + 4),*(name + 5),*(value + 5),confirm);
	printf(" path=/; Domain=%s\r\n",DOMAIN);

	/*--- e𔭌t@C֏ ---*/
	if(WRITE == 0){
		number = get_int_count("counter.dat");
		contribute_description(number, gmt, value);
		put_int_count("counter.dat",number);
		limit_description(number);
	}
	puts("Content-type: text/html\n\n");	/*CGIwb_̏o*/
	puts(BODY1);		/*BODYo*/
	printf("<BLOCKQUOTE><BR><BR><FONT SIZE=4> <B>%s</B>̔ w<B>%s</B>x <B>%d</B>ɓo^܂B</FONT><BR><BR>",*(value + 3),*value,number);
	printf("@E<A HREF=\"comment.cgi?num=%d\">̔mF</A><BR>\n",number);
	puts("@E<A HREF=\"title.cgi\" TARGET=\"frtitle\">^CgꗗXV</A></BODY></HTML>\n");

	freedata(name, value, count);/*[*/
	return 0;
}