/*---------------------------------------------------------------------------
 * cgi.c Ver3.4
 * CGIėp[eBeB
 *
 * Last update : 1998/01/01
 *
 * Copyright(C) 1997  Yuto Ikeno  All rights reserved.
 * e-mail : mew@post.co.jp
 * homepage:http://www.izanami.net/mew/
 * compile: gcc -c cgi.c
 *
 * ֐̎dlgp@
 * ==========================================================================
 * int split(char *out, char *in, char search)
 * FinAout͊֐OŐ錾ꂽÓIϐ
 * Finœ͂Asearch܂outɃRs[
 * FsearchAsearch΂Ac̕Sč[փVtgB
 *
 * char *substring(char *in, int start, int end)
 * Finstartend܂ł𔲂oB
 *
 * char *replacestring(char *in, char *search, char *replace, int *flag)
 * FinsearchTAreplaceɒuB
 * F񂪑݂Ȃꍇccflag = 0
 *
 * int searchstring(char *in, char *search)
 * FinsearchTB
 * Finsearch݂ꍇ0ԂA݂Ȃꍇ1ԂB
 *
 * void decode(char *url)
 * FGR[hĂ镶urlfR[hB
 *
 * int getdata(char ***name, char ***value)
 * FSăfR[hAnamevalueɕB
 * Fname=valuȇgԂBȋ̃G[-1Ԃj
 *
 * void freedata(char **name, char **value, count)
 * FgetdataŊmۂꂽ[
 * Fcountname=valuȇg
 *
 * int getcookiesdata(char ***cname, char ***cvalue, char *ckname)
 * FcknameŎw肳ꂽCookie擾AcnamecvalueɕB
 * Fcname=cvaluȇgԂBȋ̃G[-1Ԃj
 *
 * void fatal_error(const char* message, const char* body)
 * FBODYŎw肳ꂽF̃y[Wmessage\AvOI
 *
 * int get_int_count(const char* file_path)
 * Ffile_pathŎw肳JE^[t@Cint^̐lǂݏoAԂ
 *
 * void put_int_count(const char* file_path, int count){
 * Ffile_pathŎw肳JE^[t@Ccounter+1ď
 *
 * int check_string(char *sinput, char checkword)
 * Fsinputcheckword݂0AȂ1Ԃ
 *
 * ==========================================================================
 *-------------------------------------------------------------------------*/

/*--- Define ---*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi.h"

/*--- Code ---*/
int split(char *out, char *in, char search){

	int i = 0,j = 0;
	int flag = 1;

	while(in[i] != search && in[i]){  /*  searchɓ钼O܂ł̒l*outɑ */
		out[j] = in[i];
		i++; j++;
	}
	if(in[i] != search)/*Y镶*/
		flag = 0;
	
	out[j] = '\0';  /* *out̍ŌNULL*/
	j =0;           /* JEgϐď*/
	i++;            /*@search|C^i߂*/
	while(in[j]){   /*@c̕A擪ɃVtg */
		in[j] = in[i];
		j++; i++;
	}
	return flag;
}

char *substring(char *in, int start, int end){

	int i,j;
	static char out[255];

	if(in[0] == '\n')
		return in;

	for(i = start, j = 0; i < end; i++, j++)  /*startend܂ł̕擾*/
		out[j] = in[i];

	out[j+1] = '\0';

	return out;
}

char *replacestring(char *in, char *search, char *replace,int *flag){

	static char *out;
	int i = 0, j = 0, k, l, m = 0;

	out = (char *)malloc(strlen(in) * 5);
	*flag = 0;

	while(*(in+i) && *search){
		if(*(in+i) == *(search+j)){/*vĂꍇ*/
			if(j == 0)
				k = i;
			i++; j++;
		}else{/*vȂꍇ*/
			i++;
		}
		if(!*(search+j)){/*񂪑݂ꍇ*/
			*flag = 1;
			break;
		}
	}
	if(*flag == 1){
		for(l = 0; m < k; l++, m++)/*Y镶񂪌钼O܂*/
			out[l] = in[l];
		for(j = 0; *(replace + j); l++, j++)/*u镶*/
			out[l] = replace[j];
		for( ; *(in + i); i++, l++)/*Y镶̏I[ȍ~*/
			out[l] = in[i];
		out[l] = '\0';
		return out;
	}
	return in;/*Ȃꍇ͌̂̕܂ܕԂ*/
}

int searchstring(char *in, char *search){

	int i=0,j=0;

	while(*(in+i) && *search){
		if(*(in+i) == *(search+j)){
			i++; j++;
		}else{
			i++;
		}
		if(!*(search+j))
			return 0;
	}
	return 1;
}
char tochar(char *x){

	register char c;

	c  = (x[0] >= 'A' ? ((x[0] & 0xdf) - 'A') + 10 : (x[0] - '0'));
	c *= 16;
	c += (x[1] >= 'A' ? ((x[1] & 0xdf) - 'A') + 10 : (x[1] - '0'));
	return(c);
}

void decode(char *url){

	register int i, j;

	for(i = 0, j = 0; url[j]; ++i, ++j){
		if((url[i] = url[j]) == '%'){
			url[i] = tochar(&url[j + 1]);
			j += 2;
		}
		else if (url[i] == '+')
		url[i] = ' ';
	}
	url[i] = '\0';
}

int getdata(char ***name, char ***value){

	char *query;			/*stdin data*/
	char *method;			/*REQUEST_METHOD*/
	int ictl;				/*CONTENT_LENGTH*/
	int i;					/*JE^*/
	int count;				/*name=valuȇg*/
	char **tmpnam,**tmpval;	/*namevaluei[Qz*/

	method = getenv("REQUEST_METHOD");	/*𒲂ׂ*/
	if(method == NULL)
		method = "Unknown";

	if(!strcmp(method, "GET")){			/*GET̎*/
	
		if(getenv("QUERY_STRING") == NULL){
			return -1;
		}else{
			query = (char *)malloc(strlen(getenv("QUERY_STRING")) + 1);
			query = getenv("QUERY_STRING");
			if(*query == '\0')
				return 0;
		}

	}else if(!strcmp(method, "POST")){	/*POST̎*/

		ictl = atoi(getenv("CONTENT_LENGTH"));

		if(ictl == 0)/*󂯎f[^݂Ȃ*/
			return -1;

		if((query = (char *)malloc(ictl + 1)) == NULL)
			return -1;

		if((fread(query, ictl, 1, stdin)) != 1)
			return -1;

		query[ictl] = '\0';

	}else{								/*̑iG[j*/
		return -1;
	}

	for(i = 0, count = 0; *(query + i + 1); i++){
		if(*(query + i) == '&')
			count++;
	}
	count++;
	tmpval = (char**)malloc(sizeof(char*) * count);
	tmpnam = (char**)malloc(sizeof(char*) * count);

	/*----- fR[h -----*/
	for(i = 0; i < count; i++){
		tmpval[i] = (char*)malloc(strlen(query) + 1);
		split(*(tmpval + i), query, '&');
		decode(*(tmpval + i));
		tmpnam[i] = (char*)malloc(strlen(*(tmpval + i)) + 1);
		split(*(tmpnam + i), *(tmpval + i), '=');
	}
	*name = tmpnam;
	*value = tmpval;

	return count;
}

void freedata(char **name, char **value, int count){
	
	int i;

	for(i = 0; i < count; i++){
		free(name[i]);
		free(value[i]);
	}
	free(name);
	free(value);
}

int getcookiesdata(char ***cname, char ***cvalue, char *ckname){

	char *cookies;			/*HTTP_COOKIE*/
	char *scookie;			/*Cookie*/
	char *cookie_name;		/*Cookie's Name*/
	int i,j;				/*JE^*/
	int count;				/*name=valuȇg*/
	int flag;
	char **tmpnam,**tmpval;	/*namevaluei[Qz*/
	
	if((cookies = getenv("HTTP_COOKIE")) == NULL){
		cookies = "Unknown";
	}else{
		scookie = (char *)malloc(strlen(cookies) + 1);
		cookie_name = (char *)malloc(sizeof(char) * 100);
	}

	count = (-1);
	if(strcmp(cookies,"Unknown")){
		for(i = 0; ; i++){
			flag = split(scookie,cookies,';');
			split(cookie_name,scookie,'=');
			while(*cookie_name == ' ')			/*Xy[X*/
				cookie_name++;
			if(!strcmp(cookie_name,ckname)){
				for(i = 0, count = 0; *(scookie + i + 1); i++){
					if(*(scookie + i) == '^')
					count++;
				}
				count++;
				tmpval = (char**)malloc(sizeof(char*) * count);
				tmpnam = (char**)malloc(sizeof(char*) * count);
				for(j = 0; j < count; j++){
					tmpval[j] = (char*)malloc(strlen(scookie) + 1);
					split(*(tmpval + j), scookie, '^');
					tmpnam[j] = (char*)malloc(strlen(*(tmpval + j)) + 1);
					split(*(tmpnam + j), *(tmpval + j), '*');
				}
				*cname = tmpnam;
				*cvalue = tmpval;
				break;
			}else{
				if(flag == 0)
					break;
			}
		}
	}
	return count;
}
void fatal_error(const char* message, const char* body){
	
	puts("Content-type: text/html\n\n");
	puts("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">"
		"<HTML><HEAD><TITLE>vIG[</TITLE></HEAD>");
	puts(body);
	puts("<BLOCKQUOTE><BR><BR>");
	puts(message);
	puts("</BLOCKQUOTE></BODY></HTML>");
	
	exit(1);

}
int get_int_count(const char* file_path){

	int count;
	char buf[6];
	FILE *fp;
	
	if((fp = fopen(file_path,"r")) == NULL)
		fatal_error("JE^[t@CJ܂","<BODY>");

	fgets(buf,6,fp);
	count = atoi(buf);
	fclose(fp);

	return count;
}
void put_int_count(const char* file_path, int count){

	FILE *fp;
	
	if((fp = fopen(file_path,"w")) == NULL)
		fatal_error("JE^[t@CJ܂","<BODY>");

	fprintf(fp,"%05ld\n",(count+1));
	fclose(fp);

	return;
}

int check_string(char *sinput, char checkword){
	
	int i;
	
	for(i = 0; *(sinput + i); i++){
		if(*(sinput + i) == checkword)/**/
			return 0;
	}
	return 1;	/*Ȃ*/
}
